Subject: Re: bug#76567: 30.1; package-install-upgrade-built-in upgrades built-ins to the same version

From: Stefan Monnier <[email-masked]>
Date: Thu, 20 Mar 2025 12:09:57 -0400

> Okay, then this behavior is merely unexpected per "newer" in the
> documentation, and it's not a bug, per se.

I think it should definitely count as a bug because what appears as
a "side-grade" might really be a downgrade because version NN.MM on GNU
ELPA corresponds to the commit where `Version:` was modified to "NN.MM",
whereas the built-in version may still say `Version: NN.MM` but with
various bug fixes and improvements installed since then.

[ The problem is yet more tricky with GNU-devel ELPA, because `Version:
  NN.MM` will lead to packages with version numbers NN.MM.0.DATE.TIME,
  so they will always appear to be strictly greater than the
  built-in version.  But least there, they should indeed be the
  latest&greatest, so at least it should be at worst a side-grade, not
  a downgrade (except for corner cases, like when the creation of the
  GNU-devel tarball fails for some reason, but this should be rare
  enough).  ]

        Stefan